﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Service.Interface;

namespace Mvc3_MEF_WebApplication.Controllers
{
    [Export]
    [PartCreationPolicy(CreationPolicy.NonShared)]
    public class HomeController : Controller
    {
        private readonly IBookService _bookService;
        private readonly IPhoneService _phoneService;

        [ImportingConstructor]
        public HomeController(IBookService bookService, IPhoneService phoneService)
        {
            _bookService = bookService;
            _phoneService = phoneService;
        }

        public ActionResult Index()
        {
            ViewBag.Message = "Welcome to ASP.NET MVC!" + _bookService.GetAllBooks().ToList()[0].Name + _phoneService.GetAllPhones().ToList()[0].SerialNumber;

            return View();
        }

        public ActionResult About()
        {
            return View();
        }
    }
}
